{$G+,S-,R-,B-,D-}
unit PasString;  interface

{ Ŀ }
{  㭪樨 ८ࠧ  ॣ:   Lower, Upper      }
{  㭪樨 㭨⮦ ࠩ ஡:     LTrim, RTrim,     }
{  㭪樨 㭨⮦ ࠩ ஡:     AllTrim           }
{  㡫஢ ப Count ࠧ. ᫨                         }
{     Str*Count > 255,  㡫                     }
{    楫 ᫮  ப:               Replicate         }
{  ஢ઠ ப  ,                         }
{    ஡ ᨬ (<=Ord(' ')):    Empty             }
{  뢮 ப  ⭮ 浪:          Reverse           }
{  㭪樨 뤥 ப:              Left, Right       }
{  宦 樨 ப ࠢ:      RPos              }
{   ࢮ ᨬ  ⢠:       Match             }
{   ࢮ ᨬ   ⢥:     CMatch            }
{  뤥 ப ᮤঠ饩                              }
{    ᨬ   ⢠:         Spn               }
{  뤥 ப  ᮤঠ饩                           }
{    ᨬ   ⢠:         CSpn              }
{  祭 ப                               }
{     ᨬ-⥫:      FillStr           }
{  㭪樨 ࠢ ப  ਭ                       }
{     ᨬ-⥫:      PadR, PadL, PadC  }
{  㭪 뤠 ப, 祭                           }
{     ᨬ  㪠 ப:    Translate         }
{    ப  :            Stuff             }
{  ८ࠧ ᥫ  ப  ⭮:  Str2Long          }
{                                            Long2Str          }
{  }
{  ࣥ ஢, ࣠ pm@8552.kurgan.su }
{}

{$S-,R-,G+}

type
  SetOfChar = set of Char;

function AllTrim   (const Str: string)                       : string;  { 1 }
function CMatch    (const MSet: SetOfChar; const Str: string): Byte;    { 2 }
function CSpn      (const MSet: SetOfChar; const Str: string): string;  { 3 }
function Empty     (const Str: string)                       : Boolean; { 4 }
function FillStr   (Len: Byte)                               : string;  { 5 }
function LTrim     (const Str: string)                       : string;  { 6 }
function Left      (const Str: string; Count: Byte)          : string;  { 7 }
function Long2Str  (Num: LongInt)                            : string;  { 22 }
function Lower     (Str: string)                             : string;  { 8 }
function Match     (const MSet: SetOfChar; const Str: string): Byte;    { 9 }
function PadC      (const Str: string; Width: Byte)          : string;  { 10 }
function PadL      (const Str: string; Width: Byte)          : string;  { 11 }
function PadR      (const Str: string; Width: Byte)          : string;  { 12 }
function RPos      (const SubStr, Str: string)               : Byte;    { 13 }
function RTrim     (Str: string)                             : string;  { 14 }
function Replicate (Str: string; Count: Byte)                : string;  { 15 }
function Reverse   (const Str: string)                       : string;  { 16 }
function Right     (const Str: string; Count: Byte)          : string;  { 17 }
function Spn       (const MSet: SetOfChar; const Str: string): string;  { 18 }
function Str2Long  (const Str: string)                       : LongInt; { 23 }
function Stuff (Str: string; First, Count: Byte;
                const Insert: string)                        : string;  { 20 }
function Translate (const Str, Search, Replace: string)      : string;  { 21 }
function Upper     (Str: string)                             : string;  { 19 }

const
  Blank = ' ';
  PadFillChar: Char = Blank;

{}
                                implementation
{}

{$DEFINE ASM}

{ 22 }
function Long2Str (Num: LongInt): string;
  var
    P: ^string;
begin
  asm
      les bx,@Result
      mov WORD PTR P[0],bx
      mov WORD PTR P[2],es
  end;
  System.Str(Num, P^);
end;
{ 23 }
function Str2Long (const Str: string): LongInt;
  var
    L: LongInt;
    j: Integer;
begin
  Val(Str, L, j);
  if j <> 0 then
    L := 0;
  Str2Long := L;
end;
{ 20 }
function Stuff (Str: string; First, Count: Byte; const Insert: string): string;
begin
  Delete(Str, First, Count);
  System.Insert(Insert, Str, First);
  Stuff := Str;
end;
{ 21 }
function Translate (const Str, Search, Replace: string): string;
  var
    i, j: Integer;
    P, Len: Byte;
    C: Char;
begin
  j := 0;
  Len := Length(Replace);
  for i := 1 to Length(Str) do begin
    C := Str[i];
    P := Pos(C, Search);
    if P > 0 then
      if P <= Len then
        C := Replace[P]
      else
        continue;
    Inc(j);
    Translate[j] := C;
  end;
  Translate[0] := Chr(j);
end;
{ 1 }
function AllTrim (const Str: string): string;
begin
  AllTrim := LTrim(RTrim(Str))
end;

{$IFNDEF ASM}

{ 5 }
function FillStr (Len: Byte): string;
begin
  FillStr := Replicate(PadFillChar, Len);
end;
{ 10 }
function PadC (const Str: string; Width: Byte): string;
  var
    i: Byte;
begin
  if Width <= Length(Str) then
    PadC := Left(Str, Width)
  else begin
    i := (Width-Length(Str));
    PadC := FillStr(i div 2)+Str+FillStr(i-i div 2);
  end;
end;
{ 11 }
function PadL (const Str: string; Width: Byte): string;
begin
  if Width > Length(Str) then
    PadL := FillStr(Width-Length(Str))+Str
  else
    PadL := Left(Str, Width)
end;
{ 12 }
function PadR (const Str: string; Width: Byte): string;
begin
  PadR := Left(Str+FillStr(255), Width)
end;

{$ELSE}

{ 10 }
function PadC (const Str: string; Width: Byte): string; assembler;
asm
    cld
    mov dl,ds:[PadFillChar]
    push ds
    lds si,Str
    les di,@Result
    xor ax,ax
    mov al,Width
    stosb
    mov cx,ax
    lodsb
    cmp ax,cx
    jae @1
    mov bx,ax
    sub cx,ax
    mov al,dl
    mov dx,cx
    shr cx,1
    sub dx,cx
    jcxz @2
    REP stosb
  @2: mov cx,bx
    jcxz @3
    REP movsb
  @3: mov cx,dx
    REP stosb
    jmp @4
  @1: jcxz @4
    REP movsb
  @4: pop ds
end;
{ 11 }
function PadL (const Str: string; Width: Byte): string; assembler;
asm
    cld
    push ds
    mov dl,ds:[PadFillChar]
    lds si,Str
    les di,@Result
    xor ax,ax
    mov al,Width
    stosb
    mov cx,ax
    lodsb
    cmp ax,cx
    jae @1
    mov bx,ax
    sub cx,ax
    mov al,dl
    REP stosb
    mov cx,bx
  @1: jcxz @2
    REP movsb
  @2: pop ds
end;
{ 5 }
function FillStr (Len: Byte): string; assembler;
asm
    cld
    les di,@Result
    xor ax,ax
    mov al,Len
    stosb
    mov cx,ax
    jcxz @1
    mov al,ds:[PadFillChar]
    REP stosb
  @1:
end;
{ 12 }
function PadR (const Str: string; Width: Byte): string; assembler;
asm
    cld
    push ds
    mov dl,ds:[PadFillChar]
    lds si,Str
    les di,@Result
    xor ax,ax
    mov al,Width
    stosb
    mov bx,ax
    lodsb
    cmp ax,bx
    jbe @1
    mov ax,bx
  @1: mov cx,ax
    jcxz @2
    REP movsb
  @2: mov cx,bx
    sub cx,ax
    jcxz @3
    mov al,dl
    REP stosb
  @3: pop ds
end;

{$ENDIF}
{$IFNDEF ASM}

{ 2 }
function CMatch (const MSet: SetOfChar; const Str: string): Byte;
  var
    i: Byte;
begin
  CMatch := 0;
  for i := 1 to Length(Str) do
    if not (Str[i] in MSet) then begin
      CMatch := i;
      Exit;
  end;
end;
{ 3 }
function CSpn (const MSet: SetOfChar; const Str: string): string;
begin
  CSpn := Left(Str, Match(MSet, Str)-1);
end;
{ 4 }
function Empty (const Str: string): Boolean;
  var
    i: Word;
begin
  Empty := TRUE;
  for i := 1 to Length(Str) do
    if Str[i] > Blank then begin
      Empty := FALSE;
      Exit;
  end;
end;
{ 8 }
function Lower (Str: string): string;
  var
    i: Word;
    C: Char;
begin
  for i := 1 to Length(Str) do begin
    C := Str[i];
    if ((C>='A') and (C<='Z')) or ((C>='') and (C<='')) then
      Str[i] := Chr(Ord(C)+Ord('z')-Ord('Z'))
    else
      if (C>='') and (C<='') then
        Str[i] := Chr(Ord(C)+Ord('')-Ord(''));
  end;
  Lower := Str;
end;
{ 6 }
function LTrim (const Str: string): string;
  var
    i: Word;
begin
  i := 1;
  while (Str[i]=Blank) and (Length(Str) >= i) do
    Inc(i);
  LTrim := Copy(Str, i, 255);
end;
{ 7 }
function Left  (const Str: string; Count: Byte): string;
begin
  Left := Copy(Str, 1, Count);
end;
{ 9 }
function Match (const MSet: SetOfChar; const Str: string): Byte;
  var
    i: Byte;
begin
  Match := 0;
  for i := 1 to Length(Str) do if Str[i] in MSet then begin
    Match := i;
    Exit;
  end;
end;
{ 14 }
function RTrim (Str: string): string;
begin
  while Str[Length(Str)] = Blank do
    Dec(Str[0]);
  RTrim := Str;
end;
{ 15 }
function Replicate (Str: string; Count: Byte): string;
  var
    i: Byte;
    P: ^string;
begin
  asm
     les ax,@Result
     mov WORD PTR P[0],ax
     mov WORD PTR P[2],es
  end;
  P^ := '';
  if Length(Str)*Count > 25 then
    Count := 25 div Length(Str);
  for i := 1 to Count do
    P^ := P^+Str;
end;
{ 16 }
function Reverse (const Str: string): string;
  var
    i, Len: Word;
begin
  Len := Length(Str);
  for i := 1 to Len do
    Reverse[i] := Str[Len+1-i];
  Reverse[0] := Chr(Len);
end;
{ 17 }
function Right (const Str: string; Count: Byte): string;
begin
  Right := Copy(Str, Length(Str)-Count+1, Count);
end;
{ 13 }
function RPos (const SubStr, Str: string): Byte;
  var
    i: Byte;
begin
  i := 0;
  repeat
    RPos := i;
    i := Pos(Copy(SubStr, i, 255), Str);
  until i=0;
end;
{ 18 }
function Spn (const MSet: SetOfChar; const Str: string): string;
begin
  Spn := Left(Str, CMatch(MSet, Str)-1);
end;
{ 19 }
function Upper (Str: string): string;
  var
    i: Word;
    C: Char;
begin
  for i := 1 to Length(Str) do begin
    C := Str[i];
    if ((C>='a') and (C<='z')) or ((C>='') and (C<='')) then
      Str[i] := Chr(Ord(C)-Ord('z')+Ord('Z'))
    else
      if (C>='') and (C<='') then
        Str[i] := Chr(Ord(C)-Ord('')+Ord(''));
  end;
  Upper := Str;
end;

{$ELSE}  { IFDEF ASM }

function PMatch (const MSet: SetOfChar; const Str: string): Byte; far; assembler;
asm
        mov dx,ds
        lds si,Str
        cld
        xor  ax,ax
        lodsb
        mov cx,ax
        jcxz @Bad
        les di,MSet
        xor bx,bx
  @1:   lodsb
        mov bl,al
        shr bx,3
        and al,7
        xchg al,cl
        mov ah,1
        shl ah,cl
        mov cl,al
        test es:[di+bx],ah
  @XXX: jne @Ok
        loop @1
  @Bad: xor ax,ax
        jmp @End
  @Ok:  mov ax,si
        sub ax,WORD PTR Str[0]
        dec ax
  @End: mov ds,dx
end;

function PSpn (const MSet: SetOfChar; const Str: string): string; far; assembler;
asm
        les di,MSet
        push es
        push di
        les di,Str
        push es
        push di
        push cs
        call NEAR PTR PMatch
        les di,@Result
  @1:   dec al
        xor ah,ah
        push es
        push di
        les di,Str
        push es
        push di
        push ax
        push cs
        call NEAR PTR Left
end;

const
  XXX = 40;         {  樨 @XXX }
  JE  = $74;
  JNE = $75;

{ 2 }
function CMatch (const MSet: SetOfChar; const Str: string): Byte; assembler;
asm
  pop bp
  mov BYTE PTR cs:[NEAR PTR PMatch+XXX],JE
  jmp NEAR PTR PMatch
end;
{ 3 }
function CSpn (const MSet: SetOfChar; const Str: string): string; assembler;
asm
  pop bp
  mov BYTE PTR cs:[NEAR PTR PMatch+XXX],JNE
  jmp NEAR PTR PSpn
end;
{ 4 }
function Empty (const Str: string): Boolean; assembler;
asm
        mov al,1
        les di,Str
        xor cx,cx
        mov cl,es:[di]
        jcxz @End
  @1:   inc di
        cmp BYTE PTR es:[di],Blank
        ja @2
        loop @1
        jmp @End
  @2:   xor ax,ax
  @End:
end;
{ 8 }
function Lower (Str: string): string;  assembler;
asm
        cld
        mov dx,ds
        lds si,Str
        les di,@Result
        lodsb
        stosb
        xor ah,ah
        mov cx,ax
        jcxz @End
  @1:   lodsb
        cmp al,'A'
        jb  @3
        cmp al,'Z'
        jbe  @2
        cmp al,''  { ᪮ }
        jb  @3
        cmp al,''
        jbe  @2
        cmp al,''
        ja  @3
        add al,''-''-('z'-'Z')
  @2:   add al,'z'-'Z'
  @3:   stosb
        loop @1
  @End: mov ds,dx
end;
{ 6 }
function LTrim (const Str: string): string; assembler;
asm
        cld
        mov dx,ds
        lds si,Str
        les di,@Result
        lodsb
        xor ah,ah
        mov cx,ax
        jcxz @3
  @1:   lodsb
        cmp al,Blank
        jne @2
        loop @1
  @2:   mov al,cl
  @3:   stosb
        jcxz @End
        dec si
        REP movsb
  @End: mov ds,dx
end;
{ 7 }
function Left  (const Str: string; Count: Byte): string; assembler;
asm
        mov dx,ds
        lds si,Str
        les di,@Result
        cld
        xor ax,ax
        xor cx,cx
        lodsb
        mov cl,Count
        cmp cx,ax
        jbe @1
        mov cx,ax
  @1:   mov ax,cx
        stosb
        jcxz @End
        REP movsb
  @End: mov ds,dx
end;
{ 9 }
function Match (const MSet: SetOfChar; const Str: string): Byte; assembler;
asm
  pop bp
  mov BYTE PTR cs:[NEAR PTR PMatch+XXX],JNE
  jmp NEAR PTR PMatch
end;
{ 14 }
function RTrim (Str: string): string; assembler;
asm
        cld
        mov dx,ds
        lds si,Str
        les di,@Result
        lodsb
        stosb
        xor ah,ah
        mov cx,ax
        jcxz @End
        mov bx,si
        add si,cx
        mov al,Blank
  @1:   dec si
        cmp [si],al
        jne @2
        loop @1
  @2:   mov es:[di-1],cl
        jcxz @End
        mov si,bx
        REP movsb
  @End: mov ds,dx
end;
{ 15 }
function Replicate (Str: string; Count: Byte): string; assembler;
asm
        cld
        mov dx,ds
        lds si,Str
        les di,@Result
        xor ax,ax
        stosb
        lodsb
        or al,al
        je @End
        xor cx,cx
        mov cl,Count
        jcxz @End
        cmp al,1
        jne @1
        mov bx,cx
        lodsb
        REP stosb
        jmp @4
  @1:   inc WORD PTR Str[0]
        mov bx,ax
  @2:   or bh,bh
        jne @3
        mov cx,ax
        add bx,ax
        REP movsb
        mov si,WORD PTR Str[0]
        dec Count
        jne @2
  @3:   sub bx,ax
  @4:   mov di,WORD PTR @Result[0]
        mov es:[di],bl
  @End: mov ds,dx
end;
{ 16 }
function Reverse (const Str: string): string; assembler;
asm
        mov dx,ds
        lds si,Str
        les di,@Result
        xor cx,cx
        mov cl,[si]
        mov es:[di],cl
        jcxz @End
        add di,cx
        std
  @1:   inc si
        mov al,[si]
        stosb
        loop @1
  @End: mov ds,dx
end;
{ 17 }
function Right (const Str: string; Count: Byte): string; assembler;
asm
        mov dx,ds
        lds si,Str
        les di,@Result
        cld
        xor ax,ax
        lodsb
        mov cx,WORD PTR Count
        cmp cx,ax
        jbe @1
        mov cx,ax
  @1:   sub ax,cx
        add si,ax
        mov ax,cx
        stosb
        jcxz @End
        REP movsb
  @End: mov ds,dx
end;
{ 13 }
function RPos (const SubStr, Str: string): Byte; assembler;
asm
        push ds
        lds si,SubStr
        les di,Str
        xor cx,cx
        mov cl,[si]
        jcxz @Ok
        add si,cx
        std
        lodsb
        cmp cl,1
        je @Single
        dec cx
        mov ah,cl
        mov WORD PTR SubStr[0],si
        mov cl,es:[di]
        jcxz @Bad
        add di,cx
  @1:   REPNE scasb
        jne @Bad
        cmp cl,ah
        jb @Bad
        mov dx,di
        mov bx,cx
        mov si,WORD PTR SubStr[0]
        mov cl,ah
        REPE cmpsb
        je @Ok
        mov cx,bx
        mov di,dx
        jmp @1
  @Single: mov cl,es:[di]
        jcxz @Bad
        add di,cx
        REPNE scasb
        jne @Bad
  @Ok:  mov ax,di
        sub ax,WORD PTR Str[0]
        inc ax
        jmp @End
  @Bad: xor ax,ax
  @End: pop ds
end;
{ 18 }
function Spn (const MSet: SetOfChar; const Str: string): string; assembler;
asm
  pop bp
  mov BYTE PTR cs:[NEAR PTR PMatch+XXX],JE
  jmp NEAR PTR PSpn
end;
{ 19 }
function Upper (Str: string): string;  assembler;
asm
        cld
        mov dx,ds
        lds si,Str
        les di,@Result
        lodsb
        stosb
        xor ah,ah
        mov cx,ax
        jcxz @End
  @1:   lodsb
        cmp al,'a'
        jb  @3
        cmp al,'z'
        jbe  @2
        cmp al,''
        jb  @3
        cmp al,''
        jbe  @2
        cmp al,''
        ja  @3
        sub al,''-''-('z'-'Z')
  @2:   sub al,'z'-'Z'
  @3:   stosb
        loop @1
  @End: mov ds,dx
end;

{$ENDIF}

{ Ŀ }
{          ⠢  ஢                                    }
{  }

end.

                     {  -----      -----  }

uses PasString, Crt;

const
  S1 = '*';
  S2 = ' 2 ';
  S3 = ' error!!!  ';

procedure Wrt (S1, S2: string);
begin
  Writeln(S1, '''':43-Length(S1), S2, '''');
end;

procedure WrtN (S1: string; N: Byte);
begin
  Writeln(S1, '''':43-Length(S1), N, '''');
end;

procedure WrtB (S1: string; B: Boolean);
begin
  Writeln(S1, '''':43-Length(S1), B, '''');
end;

BEGIN
  ClrScr;
  Wrt('Lower('''+S2+''')', Lower(S2));
  Wrt('Upper('''+S2+''')', Upper(S2));
  Wrt('LTrim('''+S2+''')', LTrim(S2));
  WrtN('RPos(''r'', '''+S3+''')', RPos('r', S3));
  Wrt('RTrim('''+S2+''')', RTrim(S2));
  Wrt('Replicate('''+S1+''', 30)', Replicate(S1, 30));
  Wrt('Replicate('''+S2+''', 5)', Replicate(S2, 5));
  WrtB('Empty('''')', Empty(''));
  WrtB('Empty('''+S1+''')', Empty(S1));
  Wrt('Reverse('''+S3+''')', Reverse(S3));
  Wrt('Left('''+S3+''', 4)', Left(S3, 4));
  Wrt('Right('''+S3+''', 7)', Right(S3, 7));
  WrtN('Match([''r''], '''+S3+''')', Match(['r'], S3));
  WrtN('CMatch(['' '', [''a''..''z''], '''+S3+''')', CMatch([' ', 'a'..'z'], S3));
  Wrt('Spn(['' '', ''a''..''z''], '''+S3+''')', Spn([' ', 'a'..'z'], S3));
  Wrt('CSpn([''o''], '''+S3+''')', CSpn(['o'], S3));
END.
